use MP3::Info;

if (! -d "128") {
    mkdir( "128", 0777 ) or
        die "Failed creating dir 128: $!\n";
}

foreach (@ARGV) {
    my $info = get_mp3info($_);
    my $tags = get_mp3tag($_);
    if ( $info->{BITRATE} <= 128 ) {
        print STDERR "$_ is ".$info->{BITRATE}." kbps already\n";
        next;
    }

    if ( -f "128/$_") {
        print STDERR "128/$_ already exists\n";
        next;
    }
    $parms = "";
    $parms .= "--tt \"$tags->{TITLE}\" " if ( $tags->{TITLE} );
    $parms .= "--ta \"$tags->{ARTIST}\" " if ( $tags->{ARTIST} );
    $parms .= "--tl \"$tags->{ALBUM}\" " if ( $tags->{ALBUM} );
    $parms .= "--ty \"$tags->{YEAR}\" " if ( $tags->{YEAR} );
    $parms .= "--tn \"$tags->{TRACK}\" " if ( $tags->{TRACK} );
    $parms .= "--tc \"$tags->{COMMENT}\" " if ( $tags->{COMMENT} );
    #$parms .= "--tg \"$tags->{GENRE}\" " if ( $tags->{GENRE} );
    
    $cmd = "lame -h $parms --mp3input \"$_\" \"128/$_\"";
    $rc = system "$cmd";

    $rc /= 256;
    if ( $rc ) {
        print STDERR "Return code: $rc\n";
    }
    else {
        rename "128/$_", $_ or
            print STDERR "Failed moving 128/$_: $!\n";
    }
}

rmdir "128" or
    print STDERR "Failed removing dir 128: $!\n";
